<template>
  <div id="matching-component">
    <ClientOnly>
      <v-card v-if="!listIsEmpty" v-for="(person, index) in persons" :key="index" class="justify-center" elevation="2">
        <Person :style="{ 'z-index': index === personIndex ? 9 : 1, display: index < personIndex ? 'none' : 'flex' }"
          :class="{ person: true, removed: index === personIndex }" :center="true" :data="persons[index]" :large="true" />

        <div class="acceptance">
          <div class="icon-wrapper">
            <v-icon @click="accept" style="margin-right: 30px" size="32px">
              mdi-check-circle-outline
            </v-icon>
          </div>
          <div class="icon-wrapper">
            <v-icon @click="reject" size="32px">
              mdi-alpha-x-circle-outline
            </v-icon>
          </div>
        </div>
      </v-card>
      <div v-if="listIsEmpty" style="position: absolute; left: 32vw; top: 30vh;">Lista jest pusta</div>
      <MatchedComponent v-if="matching" @close="() => {
          matching = false;
          getNext();
        }
        " :person="persons[personIndex]" />
    </ClientOnly>
  </div>
</template>
<script>
import getPersons from "~/mixins/getPersons";
import MatchedComponent from "./MatchedComponent.vue";
export default {
  name: "CommunicatorComponent",
  mixins: [getPersons],
  data() {
    return {
      personIndex: 0,
      persons: [],
      matching: false,
      listIsEmpty: false
    };
  },
  mounted() {
    const $footer = document.querySelector('footer');
    $footer.style.position = 'absolute';
    $footer.style.bottom = '-200px';
  },
  methods: {
    getNext() {
      if (this.personIndex < this.persons.length + 1) {
        setTimeout(() => {
          this.personIndex = this.personIndex + 1;
          if (!this.persons[this.personIndex]) {
            this.listIsEmpty = true;
            this.$forceUpdate();
            return;
          }

        }, 500);
      }
    },
    accept() {

      // if(!this.persons[this.personIndex+1]) {
      //   this.listIsEmpty = true;
      //   this.$forceUpdate();
      //   return;
      // }
      this.$axios
        .put(this.$config.serverUrl + '/user/accept', {
          uuid: this.$store.state.user.uuid,
          nick: this.persons[this.personIndex].nick,
        })
        .then(({ data }) => {
          if (data.relation === 'accepted') {
            this.matching = true;
          } else {
            this.getNext();
          }
        })
        .catch((err) => {
          console.error(err);
        });

      //   this.getNext();

    },
    reject() {
      if (!this.persons[this.personIndex + 1]) {
        this.listIsEmpty = true;
        return;
      }
      this.$axios.put(this.$config.serverUrl + "/user/reject", {
        uuid: this.$store.state.user.uuid,
        nick: this.persons[this.personIndex].nick
      });
      this.getNext();
    },
  },
};
</script>
<style scoped lang="scss">
#matching-component {
  //    transform: translateY(-10px);
  position: relative;
  top: -2px;

  .person {
    top: 30px;
    right: calc(50vw - 290px);
    position: absolute;

    .removed {
      transition: all 0.5s ease-in;
      opacity: 0;
    }
  }

  .acceptance {
    display: flex;
    flex-direction: row;
    justify-content: center;
    height: 276px;
    right: calc(50vw - 190px);
    position: absolute;
    top: 347px;

    & .icon-wrapper {
      border-radius: 50%;
    }

    &>*:first-child>* {
      font-size: 32px;
      z-index: 99;
      right: 45px;
      bottom: 64px;
      color: rgb(184, 240, 175);
      text-shadow: 4px 4px 6px rgba(66, 68, 90, 1);
    }

    &>*:last-child>* {
      font-size: 32px;
      left: 39px;
      z-index: 99;
      right: 45px;
      bottom: 64px;
      color: rgba(255, 132, 113);
      text-shadow: 4px 4px 6px rgba(200, 200, 200, 1);
    }
  }
}
.v-application--is-ltr .v-responsive__sizer ~ .v-responsive__content {
  width: 1024px;
}

#matching-component > div > div.person.center.large.person.removed > div.v-image.v-responsive.image.theme--light > div.v-responsive__content {
  width: 1024px;
}
footer {
  position: absolute;
  width: 100%;
  bottom: -200px
}
</style>
